SystemOrganization addCategory: #'OmniBrowser-Tests'!
SystemOrganization addCategory: #'OmniBrowser-Kernel'!
SystemOrganization addCategory: #'OmniBrowser-Morphs'!
SystemOrganization addCategory: #'OmniBrowser-Nodes'!
SystemOrganization addCategory: #'OmniBrowser-Actors'!
SystemOrganization addCategory: #'OmniBrowser-Utilities'!

Notification subclass: #OBFileListChanged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBFileListChanged methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:57'!
notify: aColumn
	aColumn listChanged! !

Notification subclass: #OBNodeDeleted
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBNodeDeleted methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:56'!
notify: aColumn
	aColumn nodeDeleted! !

Object subclass: #OBNodeActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Actors'!

!OBNodeActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:24'!
actionsForNode: aNode
	^ aNode actions! !

Object subclass: #OBColumn
	instanceVariableNames: 'browser metaNode parent children selection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBColumn class methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 22:39'!
inBrowser: aBrowser parent: aNode
	^ self new
			browser: aBrowser;
			parent: aNode! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 1/7/2004 08:41'!
listMorph
	^ (PluggableListMorph
		on: self
		list: #list
		selected: #selection
		changeSelected: #selection:
		menu: #menu:
		keystroke: #keystroke:from:)
			borderWidth: 0! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 12/14/2003 21:19'!
selection: anInteger
	selection _ anInteger.
	self changed: #selection.
	browser columnClicked: self.! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 11/5/2003 19:01'!
selection
	^ selection ifNil: [0]! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/7/2004 08:39'!
keystroke: aChar from: aMorph! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/23/2004 23:20'!
menu: aMenu
	self actionsForSelectedNode
		do: [:action | 
			action addItemToMenu: aMenu.
			action monitor: self].
	^ aMenu! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 1/24/2004 00:08'!
metaNode
	^ metaNode! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 12/15/2003 22:46'!
parent: aNode
	parent _ aNode.
	self refresh.! !

!OBColumn methodsFor: 'accessing' stamp: 'cwp 12/14/2003 21:18'!
browser: aBrowser
	browser _ aBrowser! !

!OBColumn class methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:05'!
inBrowser: aBrowser metaNode: aMetaNode node: aNode
	^ self new
			setBrowser: aBrowser
			metaNode: aMetaNode
			node: aNode! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 1/24/2004 01:04'!
listChanged
	self refresh.
	self changed: #list! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 1/23/2004 23:57'!
refresh
	children _ self metaNode nodesForParent: parent! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 12/15/2003 21:37'!
text: aText
	self selectedNode text: aText.
	self changed: #list! !

!OBColumn methodsFor: 'initializing' stamp: 'cwp 1/24/2004 00:09'!
setBrowser: aBrowser metaNode: aMetaNode node: aNode
	browser _ aBrowser.
	metaNode _ aMetaNode.
	parent _ aNode.
	self refresh! !

!OBColumn methodsFor: 'accessing' stamp: 'avi 1/26/2004 13:02'!
next
	| nextNode |
	nextNode _ self metaNode childFor: self selectedNode.
	^ nextNode hasChildren ifTrue:
		[self class 
			inBrowser: browser
			metaNode: nextNode
			node: self selectedNode]! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 12/14/2003 22:19'!
buttonMorph
	^ (PluggableButtonMorph on: self getState: nil action: nil)
			label: '-- all --';
			onColor: Color white darker offColor: Color white darker;
			borderWidth: 2;
			borderRaised;
			hResizing: #spaceFill;
			vResizing: #spaceFill! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 1/24/2004 00:55'!
nodeDeleted
	"This gets called by OBNodeDelete if an action causes the currently selected to be deleted."

	self refresh.
	self selection: 0.
! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 12/14/2003 22:23'!
morph
	^ browser hasFilters
		ifTrue: [self columnWithHeader]
		ifFalse: [self simpleColumn]	! !

!OBColumn methodsFor: 'callbacks' stamp: 'cwp 1/24/2004 01:03'!
list
	^ children 
		ifNil: [#()]
		ifNotNil: [children collect: [:ea | ea name]]! !

!OBColumn methodsFor: 'updating' stamp: 'cwp 1/24/2004 00:54'!
notification: aNotification
	aNotification notify: self.! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 12/14/2003 22:22'!
columnWithHeader
	| col bh |
	col _ BorderedMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		clipSubmorphs: true;
		color: Color transparent;
		cellInset: 0;
		borderWidth: 0;
		layoutPolicy: ProportionalLayout new.
	
	bh _ self buttonHeight.
	col
		addMorph: self buttonMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0@bh)).
		
	col
		addMorph: self listMorph
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@bh corner: 0@0)).

	^ col! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 12/14/2003 22:15'!
buttonHeight
	^ 20! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 12/15/2003 22:35'!
selectedNode
	^ children at: selection ifAbsent: [].! !

!OBColumn methodsFor: 'nodes' stamp: 'cwp 1/23/2004 23:49'!
actionsForSelectedNode
	| node meta |
	node _ children at: selection ifAbsent: [^ #()].
	meta _ self metaNode children detect: [:child | child nodeClass = node class].
	^ meta actionsForNode: node	! !

!OBColumn methodsFor: 'morphs' stamp: 'cwp 12/14/2003 22:22'!
simpleColumn
	^ self listMorph! !

Object subclass: #OBFakeClassB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

Object subclass: #OBNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

OBNode subclass: #OBPackageNode
	instanceVariableNames: 'package '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 12/10/2003 22:29'!
package: aPackage
	package _ aPackage! !

!OBPackageNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 22:29'!
on: aPackage
	^ self new package: aPackage! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 12/15/2003 21:22'!
categories
	^ package categories collect: [:cat | OBClassCategoryNode on: cat inContext: package]! !

!OBPackageNode methodsFor: 'public' stamp: 'cwp 12/10/2003 22:39'!
name
	^ package packageName! !

!OBPackageNode methodsFor: 'accessing' stamp: 'cwp 12/15/2003 21:23'!
classes
	^ package classes 
				collect: [:class | OBClassNode on: class inContext: package]! !

OBNode subclass: #OBClassNode
	instanceVariableNames: 'class context '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBClassNode methodsFor: 'initializing' stamp: 'cwp 12/10/2003 22:48'!
setClass: aClass context: aCodeContext
	class _ aClass.
	context _ aCodeContext! !

!OBClassNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 22:47'!
on: aClass inContext: aCodeContext
	^ self new setClass: aClass context: aCodeContext! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 12/17/2003 18:20'!
categories
	^ (context coreCategoriesForClass: class)
		collect: [:cat | OBMethodCategoryNode on: cat inClass: class inContext: context]! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 12/10/2003 23:47'!
text
	^ class definition! !

!OBClassNode methodsFor: 'public' stamp: 'cwp 12/10/2003 22:49'!
name
	^ class name! !

!OBNode methodsFor: 'public' stamp: 'cwp 12/10/2003 22:27'!
name
	self subclassResponsibility! !

OBNode subclass: #OBClassCategoryNode
	instanceVariableNames: 'name context '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 12/10/2003 23:18'!
name
	^ name! !

!OBClassCategoryNode methodsFor: 'public' stamp: 'cwp 12/17/2003 18:16'!
classes
	^ (context classesInCategory: name) 
		collect: [:class | OBClassNode on: class inContext: context]! !

!OBClassCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:17'!
on: aString inContext: aCodeContext
	^ self new setName: aString context: aCodeContext! !

!OBClassCategoryNode methodsFor: 'initializing' stamp: 'cwp 12/14/2003 21:08'!
setName: aString context: aCodeContext
	name _ aString.
	context _ aCodeContext.
! !

OBNode subclass: #OBMetaNodeNode
	instanceVariableNames: 'metaNode '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:32'!
metaNode: aMetaNode
	metaNode _ aMetaNode! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:15'!
children
	^ metaNode children collect: [:mn | OBMetaNodeNode on: mn]! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:58'!
name
	^ metaNode nodeClass name! !

!OBMetaNodeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:15'!
on: aMetaNode
	^ self new metaNode: aMetaNode! !

!OBMetaNodeNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:26'!
text
	^ 'OBMetaNode on: ', metaNode nodeClass name! !

OBNode subclass: #OBSystemNode
	instanceVariableNames: 'context '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:22'!
packages
	^ context packages collect: [:aPackage | OBPackageNode on: aPackage]! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:26'!
categories
	^ context categories collect: [:cat | OBClassCategoryNode on: cat inContext: context]! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 06:21'!
name 
	^ 'Squeak'! !

!OBSystemNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:19'!
on: aCodeContext
	^ self new context: aCodeContext! !

!OBSystemNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 20:18'!
context: aCodeContext
	context _ aCodeContext! !

!OBNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:11'!
fromAssociation: anAssociationNode
	^ self on: anAssociationNode value! !

!OBNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:27'!
text
	^ ''! !

!OBNode methodsFor: 'public' stamp: 'cwp 1/7/2004 09:25'!
actions
	^ #()! !

!OBNode methodsFor: 'utility' stamp: 'cwp 1/7/2004 09:26'!
actionWithLabel: aString selector: aSelector
	^ OBAction
		label: aString
		receiver: self
		selector: aSelector
		arguments: #()! !

!OBNode methodsFor: 'public' stamp: 'cwp 12/8/2003 21:49'!
text: aText
	! !

OBNode subclass: #OBDictionaryNode
	instanceVariableNames: 'dictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBDictionaryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:01'!
on: aDictionary
	^ self new dictionary: aDictionary! !

!OBDictionaryNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:13'!
associations
	^ dictionary keys asArray 
		collect: [:key | OBAssociationNode key: key value: (dictionary at: key)]! !

!OBDictionaryNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:00'!
dictionary: aDictionary
	dictionary _ aDictionary! !

OBNode subclass: #OBDirectoryNode
	instanceVariableNames: 'directory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/6/2003 17:43'!
textForDirectory: aFilename
	| entry |
	entry _ directory entryAt: aFilename.
	^ String streamContents: [:stream |
			stream 
				nextPutAll: 'Directory: '; 
				nextPutAll: (directory fullNameFor: aFilename); cr;
				nextPutAll: 'Created: '; nextPutAll: (entry at: 2) asString; cr;
				nextPutAll: 'Modified: '; nextPutAll: (entry at: 3) asString; cr;
				nextPutAll: 'Size: '; nextPutAll: (entry at: 5) asString; cr;
				cr; nextPutAll: '----------'; cr.

			directory entries do: [:e | self displayEntry: e on: stream]

	]! !

!OBDirectoryNode methodsFor: 'children' stamp: 'cwp 12/17/2003 14:51'!
files
	^ directory fileNames 
		collect: [:name | OBFileNode on: (directory fullNameFor: name)]
	! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 11/28/2003 21:57'!
directory: aFileDirectory
	directory _ aFileDirectory! !

!OBDirectoryNode methodsFor: 'children' stamp: 'cwp 12/17/2003 15:01'!
directories
	^ directory directoryNames 
		collect: [:name | OBDirectoryNode on: (directory directoryNamed: name)]
	! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/6/2003 18:01'!
displayEntry: entry on: aStream
	aStream nextPutAll: (entry at: 1).
	aStream nextPutAll: ' - '.
	aStream nextPutAll: (entry at: 5) asString, ' bytes'.
	aStream cr.! !

!OBDirectoryNode methodsFor: 'private' stamp: 'cwp 12/15/2003 21:37'!
nodeForEntry: anEntry
	^ (anEntry at: 4)
		ifTrue: [OBDirectoryNode on: (directory directoryNamed: (anEntry at: 1))]
		ifFalse: [OBFileNode on: (directory fullNameFor: (anEntry at: 1))]! !

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:51'!
name
	^ directory localName! !

!OBDirectoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 21:57'!
on: aFileDirectory
	^ self new directory: aFileDirectory! !

!OBDirectoryNode methodsFor: 'public' stamp: 'cwp 12/7/2003 19:47'!
text
	| entry |
	entry _ directory directoryEntry.
	^ String streamContents: [:stream |
			stream 
				nextPutAll: 'Directory: '; 
				nextPutAll: (directory fullNameFor: (entry at: 1)); cr;
				nextPutAll: 'Created: '; nextPutAll: (entry at: 2) asString; cr;
				nextPutAll: 'Modified: '; nextPutAll: (entry at: 3) asString; cr;
				nextPutAll: 'Size: '; nextPutAll: (entry at: 5) asString; cr;
				cr; nextPutAll: '----------'; cr.

			directory entries do: [:e | self displayEntry: e on: stream]

	]! !

OBNode subclass: #OBAssociationNode
	instanceVariableNames: 'key value '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBAssociationNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:14'!
key: keyObject value: valueObject
	^ self new setKey: keyObject value: valueObject! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:15'!
name
	^ key! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 22:13'!
value
	^ value! !

!OBAssociationNode methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:10'!
setKey: keyObject value: valueObject
	key _ keyObject.
	value _ valueObject.! !

OBNode subclass: #OBFakeNode
	instanceVariableNames: 'item parent children '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeNode methodsFor: 'public' stamp: 'cwp 1/23/2004 21:42'!
children
	^ children 
		ifNil: [children _ (self item endsWith: 'c')
					ifTrue: [Array new]
					ifFalse: [#($a $b $c) collect: [:i | OBFakeNode parent: self item: i asString]]]! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 1/23/2004 21:47'!
removeChild: aFakeNode
	children _ children copyWithout: aFakeNode! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 1/23/2004 21:50'!
delete
	parent ifNotNil: [parent removeChild: self].
	OBNodeDeleted new signal.	! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:09'!
item: aSymbol
	item _ aSymbol! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:05'!
name
	^ self parentName, self item ! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:04'!
parentName
	^ (parent ifNil: [''] ifNotNil: [parent name])! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:04'!
text: aText
	self item:( aText asString allButFirst: (self parentName size))! !

!OBFakeNode methodsFor: 'actions' stamp: 'cwp 1/7/2004 09:29'!
beZ
	item _ 'z'! !

!OBFakeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:31'!
metaGraph
	| fake |
	fake _ OBMetaNode for: OBFakeNode.
	fake 
		childAt: #children put: fake;
		addActor: OBNodeActor new.
	^ fake! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/7/2003 19:18'!
item
	^ item ifNil: [item _ '']! !

!OBFakeNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 22:06'!
parent: aFakeNode item: aString
	^ self new parent: aFakeNode; item: aString! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 12/15/2003 22:03'!
text
	^ self name! !

!OBFakeNode methodsFor: 'public' stamp: 'cwp 1/23/2004 21:34'!
actions
	^ Array 
		with: (self actionWithLabel: 'become z' selector: #beZ)
		with: (self actionWithLabel: 'delete' selector: #delete)! !

!OBFakeNode methodsFor: 'private' stamp: 'cwp 12/15/2003 22:01'!
parent: aFakeNode
	parent _ aFakeNode! !

OBNode subclass: #OBFileNode
	instanceVariableNames: 'path '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/8/2003 22:20'!
text: aText
	| file |
	file _ self openFile.
	file
		reset;
		nextPutAll: aText asString;
		truncate: (file position);
		close! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/8/2003 22:21'!
openFile
	^ FileStream oldFileNamed: path! !

!OBFileNode methodsFor: 'accessing' stamp: 'cwp 12/7/2003 19:44'!
path: aPath
	path _ aPath! !

!OBFileNode methodsFor: 'accessing' stamp: 'cwp 1/24/2004 00:16'!
path
	^ path! !

!OBFileNode methodsFor: 'actions' stamp: 'cwp 1/23/2004 23:14'!
delete
	FileDirectory deleteFilePath: path.
	OBNodeDeleted new signal.	! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 12/7/2003 20:00'!
name
	^ FileDirectory localNameFor: path! !

!OBFileNode class methodsFor: 'instance creation' stamp: 'cwp 12/7/2003 19:43'!
on: aPath
	^ self new path: aPath! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 1/7/2004 21:33'!
actions
	^ Array with: (self actionWithLabel: 'delete' selector: #delete)! !

!OBFileNode methodsFor: 'public' stamp: 'cwp 1/23/2004 22:55'!
text
	| file text |
	file _ self openFile.
	text _ file contentsOfEntireFile.
	file close.
	^ text! !

OBNode subclass: #OBMethodCategoryNode
	instanceVariableNames: 'name class context '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMethodCategoryNode methodsFor: 'accessing' stamp: 'cwp 12/17/2003 18:23'!
methodReferences
	| organization methods |
	organization _ class organization.
	methods _ ((context coreMethodsForClass: class), (context extensionMethodsForClass: class))
		select: [:m | (organization categoryOfElement: m methodSymbol) = name].
	^ methods asArray sort! !

!OBMethodCategoryNode methodsFor: 'initializing' stamp: 'cwp 12/10/2003 23:09'!
setName: aString class: aClass context: aCodeContext
	name _ aString.
	class _  aClass.
	context _ aCodeContext! !

!OBMethodCategoryNode methodsFor: 'children' stamp: 'cwp 12/17/2003 18:25'!
methods
	^ self methodReferences collect: [:ref | OBMethodNode on: ref inContext: context]! !

!OBMethodCategoryNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:08'!
on: aString inClass: aClass inContext: aCodeContext
	^ self new setName: aString class: aClass context: aCodeContext! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 12/10/2003 23:10'!
name
	^ name! !

!OBMethodCategoryNode methodsFor: 'public' stamp: 'cwp 12/11/2003 00:06'!
text
	^ class name, ' organization addCategory: ''', name, ''''! !

OBNode subclass: #OBMethodNode
	instanceVariableNames: 'reference context '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Nodes'!

!OBMethodNode methodsFor: 'public' stamp: 'cwp 12/11/2003 00:00'!
name
	^ reference methodSymbol! !

!OBMethodNode methodsFor: 'initializing' stamp: 'cwp 12/10/2003 23:52'!
setReference: aMethodReference context: aCodeContext
	reference _ aMethodReference.
	context _ aCodeContext! !

!OBMethodNode methodsFor: 'public' stamp: 'cwp 12/11/2003 00:11'!
text
	^ reference source! !

!OBMethodNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:51'!
on: aMethodReference inContext: aCodeContext
	^ self new setReference: aMethodReference context: aCodeContext! !

Object subclass: #OBFileRegistryActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Actors'!

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 01:05'!
update: aParameter
	(aParameter == #fileListChanged) ifTrue: [self updateFileList].
	super update: aParameter! !

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 01:11'!
actionsForNode: aFileNode
	| services actions |
	services _ FileList itemsForFile: aFileNode path.
	services do: [:svc | svc addDependent: self].
	actions _ services collect: [:s | OBAction
							label: s label
							receiver: s
							selector: s requestSelector
							arguments: (Array with: aFileNode path)].
	^ actions! !

!OBFileRegistryActor methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:50'!
updateFileList
	OBFileListChanged new signal! !

Object subclass: #OBBrowser
	instanceVariableNames: 'columns scroller '
	classVariableNames: 'MetaGraphs '
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 11/23/2003 18:02'!
label
	^ 'OmniBrowser'! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 1/26/2004 21:47'!
currentNode
	^ self currentColumn ifNotNilDo: [:column | column selectedNode]! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 12/22/2003 22:27'!
browsePackages
	^ self 
		browse: #System
		fromRoot: (OBSystemNode on: OBImageContext new)
! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 12/17/2003 16:38'!
metaNode: aMetaNode node: aNode
	^ self new setMetaNode: aMetaNode node: aNode! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 12/8/2003 20:18'!
updateMorphs
	scroller clearPanes.
	columns do: [:c | scroller addPane: c morph].
	(self minPanes - columns size) timesRepeat: [scroller addPane: self emptyPane].
	scroller doLayout.
	self changed: #text.! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 12/14/2003 21:20'!
columnClicked: aColumn
	aColumn selection = 0
		ifTrue: [self deselected: aColumn]
		ifFalse: [self selected: aColumn]! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 12/18/2003 22:24'!
browseMetaGraphs
	(OBBrowser
		metaNode: OBMetaGraphBuilder default metaGraphBrowser
		node: (OBDictionaryNode on: MetaGraphs)) open! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 12/8/2003 20:18'!
minPanes
	^ 4! !

!OBBrowser methodsFor: 'callbacks' stamp: 'cwp 1/26/2004 21:45'!
text
	| node |
	node _ self currentNode.
	^ node 
		ifNil: ['']
		ifNotNil: [node text]! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 12/14/2003 22:21'!
hasFilters
	^ false! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 19:50'!
metaGraphs
	^ MetaGraphs! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 18:13'!
removeMetaGraphAt: aSymbol
	MetaGraphs removeKey: aSymbol! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 11/29/2003 17:38'!
textPane
	^ PluggableTextMorph
		on: self
		text: #text
		accept: #text:! !

!OBBrowser methodsFor: 'callbacks' stamp: 'cwp 1/26/2004 21:48'!
text: aText
	self currentColumn ifNotNilDo: [:column | 
									column text: aText.
									self changed: #text]! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 18:13'!
metaGraphAt: aSymbol put: aMetaGraph
	MetaGraphs at: aSymbol put: aMetaGraph! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 11/29/2003 17:37'!
window
	| window |
	window _ SystemWindow labelled: self label.
	window model: self.
	window 
		addMorph: self scroller
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.4)).
	window
		addMorph: self textPane
		fullFrame: (LayoutFrame fractions: (0@0.4 corner: 1@1)).
	^ window! !

!OBBrowser methodsFor: 'updating' stamp: 'avi 1/26/2004 13:03'!
selected: aColumn
	| index |
	index _ columns indexOf: aColumn.
	columns _ columns first: index.
	aColumn next ifNotNilDo: [:next | columns add: next].
	self updateMorphs! !

!OBBrowser methodsFor: 'initializing' stamp: 'cwp 1/24/2004 00:02'!
setMetaNode: aMetaNode node: aNode
	columns _ OrderedCollection with: (OBColumn 
										inBrowser: self 
										metaNode: aMetaNode
										node: aNode)! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 12/22/2003 22:27'!
browseFileSystem
	^ self 
		browse: #FileSystem
		fromRoot: (OBDirectoryNode on: FileDirectory root)! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 12/3/2003 13:46'!
deselected: aColumn
	| index |
	index _ columns indexOf: aColumn.
	columns _ columns first: index.
	self updateMorphs! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 12/8/2003 20:25'!
scroller
	^ scroller ifNil: [scroller _ OBPaneScroller new.
					scroller 
						name: 'scroller';
						vResizing: #spaceFill;
						hResizing: #spaceFill.
					self updateMorphs.
					scroller]
	! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 12/10/2003 22:51'!
open
	^ self window openInWorld! !

!OBBrowser methodsFor: 'constructing' stamp: 'cwp 12/8/2003 20:21'!
emptyPane
	^ RectangleMorph new color: Color white! !

!OBBrowser methodsFor: 'updating' stamp: 'cwp 1/26/2004 21:46'!
currentColumn
	^ columns reversed detect: [:ea | ea selection > 0] ifNone: []
! !

!OBBrowser class methodsFor: 'initialize-release' stamp: 'cwp 12/18/2003 18:11'!
initialize
	MetaGraphs _ Dictionary new! !

!OBBrowser class methodsFor: 'instance creation' stamp: 'cwp 12/22/2003 22:26'!
browse: aSymbol fromRoot: aNode
	^ (self metaNode: (MetaGraphs at: aSymbol) node: aNode) open! !

!OBBrowser class methodsFor: 'metaGraphs' stamp: 'cwp 12/18/2003 19:45'!
metaGraphAt: aSymbol
	^ MetaGraphs at: aSymbol! !

!OBBrowser class methodsFor: 'convenience' stamp: 'cwp 12/22/2003 22:27'!
browseImage
	^ self 
		browse: #Image
		fromRoot: (OBSystemNode on: OBImageContext new)
! !

Object subclass: #OBImageContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBImageContext methodsFor: 'public' stamp: 'cwp 12/17/2003 20:51'!
coreMethodsForClass: aClass
	^ aClass selectors asArray collect: [:sel | self referenceForMethod: sel ofClass: aClass]! !

!OBImageContext methodsFor: 'public' stamp: 'cwp 12/17/2003 20:23'!
packages
	^ PackageInfo allPackages! !

!OBImageContext methodsFor: 'public' stamp: 'cwp 12/17/2003 20:44'!
classesInCategory: aCategory
	^ (SystemOrganization listAtCategoryNamed: aCategory asSymbol) 
			collect: [:title | Smalltalk at: title]! !

!OBImageContext methodsFor: 'public' stamp: 'cwp 12/17/2003 20:40'!
categories
	^ SystemOrganization categories! !

!OBImageContext methodsFor: 'private' stamp: 'cwp 12/17/2003 20:50'!
referenceForMethod: aSymbol ofClass: aClass
	^ MethodReference new setStandardClass: aClass methodSymbol: aSymbol! !

!OBImageContext methodsFor: 'public' stamp: 'cwp 12/17/2003 20:50'!
extensionMethodsForClass: aClass
	^ #()! !

!OBImageContext methodsFor: 'public' stamp: 'cwp 12/17/2003 20:47'!
coreCategoriesForClass: aClass
	^ aClass organization categories! !

Object subclass: #OBFakeClassC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

Object subclass: #OBMetaGraphBuilder
	instanceVariableNames: ''
	classVariableNames: 'Instance '
	poolDictionaries: ''
	category: 'OmniBrowser-Utilities'!

!OBMetaGraphBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:31'!
default
	^ Instance! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:28'!
systemBrowser
	^ (OBMetaNode for: OBSystemNode)
		childAt: #packages put: self packageBrowser! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 1/24/2004 00:34'!
fileSystemBrowser
	| directory file |
	directory _ OBMetaNode for: OBDirectoryNode.
	file _ OBMetaNode for: OBFileNode.
	file 
		addActor: OBNodeActor new;
		addActor: OBFileRegistryActor new.
	directory 
		childAt: #directories put: directory;
		childAt: #files put: file.
	^ directory! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:23'!
packageBrowser
	^ (OBMetaNode for: OBPackageNode)
		childAt: #categories put: self catClassCatMethod
	! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 18:28'!
imageBrowser
	^ (OBMetaNode for: OBSystemNode)
		childAt: #categories put: self catClassCatMethod! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 22:11'!
metaGraphBrowser
	| dict assoc metaNode |
	dict _ OBMetaNode on: OBDictionaryNode.
	assoc _ OBMetaNode on: OBAssociationNode.
	metaNode _ OBMetaNode on: OBMetaNodeNode.
	
	dict childAt: #associations put: assoc.
	assoc childAt: #fromAssociation: put: metaNode.
	metaNode childAt: #children put: metaNode.

	^ dict ! !

!OBMetaGraphBuilder methodsFor: 'public' stamp: 'cwp 12/18/2003 19:35'!
installGraphs
	OBBrowser 
		metaGraphAt: #System put: self systemBrowser;
		metaGraphAt: #Image put: self imageBrowser;
		metaGraphAt: #Package put: self packageBrowser;
		metaGraphAt: #FileSystem put: self fileSystemBrowser
	! !

!OBMetaGraphBuilder class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:33'!
initialize
	Instance _ self new.
	Instance installGraphs! !

!OBMetaGraphBuilder methodsFor: 'private' stamp: 'cwp 12/18/2003 18:21'!
catClassCatMethod
	| classCategory klass methodCategory method |
	classCategory _ OBMetaNode for: OBClassCategoryNode.
	klass _ OBMetaNode for: OBClassNode.
	methodCategory _ OBMetaNode for: OBMethodCategoryNode.
	method _ OBMetaNode for: OBMethodNode.

	classCategory childAt: #classes put: klass.
	klass childAt: #categories put: methodCategory.
	methodCategory childAt: #methods put: method.
	
	^ classCategory! !

Object subclass: #OBFakeClassA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 12/10/2003 23:05'!
two
	^ 2! !

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 12/10/2003 23:05'!
one
	^ 1
! !

!OBFakeClassA methodsFor: 'letters' stamp: 'cwp 12/10/2003 23:05'!
a
	^ $a! !

!OBFakeClassA methodsFor: 'numbers' stamp: 'cwp 12/11/2003 20:57'!
three
	^ 3! !

!OBFakeClassA methodsFor: 'letters' stamp: 'cwp 12/10/2003 23:06'!
b
	^ $b! !

Object subclass: #OBMetaNode
	instanceVariableNames: 'nodeClass associations actors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBMetaNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 17:45'!
for: aNodeClass
	^ self new setNodeClass: aNodeClass! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 1/23/2004 23:44'!
childAt: aSelector put: aMetaNode
	associations add: (Association key: aSelector value: aMetaNode)! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 12/18/2003 20:57'!
nodesForMetaNode: aMetaNode parent: aNode selector: aSelector
	^ aSelector isUnary
		ifTrue: [aNode perform: aSelector]
		ifFalse: [Array with: (aMetaNode nodeClass perform: aSelector with: aNode)]! !

!OBMetaNode methodsFor: 'children' stamp: 'avi 1/26/2004 13:01'!
hasChildren
	^ associations isEmpty not! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 1/24/2004 00:07'!
childFor: aNode
	^ (associations detect: [:assoc | assoc value nodeClass = aNode class]) value! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 12/18/2003 20:48'!
nodeClass
	^ nodeClass! !

!OBMetaNode methodsFor: 'actors' stamp: 'cwp 1/23/2004 23:25'!
actionsForNode: aNode
	^ actors gather: [:actor | actor actionsForNode: aNode]! !

!OBMetaNode class methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:34'!
on: aNodeClass
	^ self new setNodeClass: aNodeClass! !

!OBMetaNode methodsFor: 'initializing' stamp: 'cwp 1/23/2004 23:43'!
setNodeClass: aNodeClass
	nodeClass _ aNodeClass.
	associations _ OrderedCollection new.
	actors _ OrderedCollection new.! !

!OBMetaNode methodsFor: 'children' stamp: 'cwp 1/23/2004 23:43'!
children
	^ associations collect: [:assoc | assoc value]! !

!OBMetaNode methodsFor: 'actors' stamp: 'cwp 1/23/2004 22:29'!
addActor: aClass
	actors add: aClass! !

!OBMetaNode methodsFor: 'nodes' stamp: 'cwp 1/23/2004 23:43'!
nodesForParent: aNode
	^ (aNode isMemberOf: nodeClass)
		ifTrue: [associations gather: [:assoc | self 
											nodesForMetaNode: assoc value 
											parent: aNode
											selector: assoc key]]
		ifFalse: [Array new]! !

MessageSend subclass: #OBAction
	instanceVariableNames: 'label monitor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Kernel'!

!OBAction methodsFor: 'evaluating' stamp: 'cwp 1/7/2004 18:22'!
perform: aSelector orSendTo: anObject
	^ self perform: aSelector! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:12'!
label: aString
	label _ aString! !

!OBAction class methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 09:20'!
label: aString receiver: anObject selector: aSelector arguments: anArray
	^ (self receiver: anObject selector: aSelector arguments: anArray) label: aString! !

!OBAction methodsFor: 'evaluating' stamp: 'cwp 1/23/2004 21:20'!
trigger
	[self value]
		on: Notification
		do: [:aNotification | 
			monitor notification: aNotification. 
			aNotification resume].! !

!OBAction methodsFor: 'morphic' stamp: 'cwp 1/7/2004 09:52'!
addItemToMenu: aMenu
	aMenu
		add: label
		target: self 
		selector: #trigger! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:59'!
monitor: anObject
	monitor _ anObject! !

!OBAction methodsFor: 'accessing' stamp: 'cwp 1/7/2004 09:11'!
label
	^ label! !

RectangleMorph subclass: #OBPaneScroller
	instanceVariableNames: 'background transform scrollBar '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/25/2003 21:20'!
bounds: aRectangle
	super bounds: aRectangle.
	self doLayout.! !

!OBPaneScroller methodsFor: 'input events' stamp: 'cwp 8/25/2003 20:33'!
scrollBarValue: value
	transform hasSubmorphs ifFalse: [^ self].
	transform offset: (self leftoverScrollRange * value) rounded @ 0.! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 21:14'!
setScrollDeltas
	| range interval value |
	transform hasSubmorphs ifFalse: [scrollBar interval: 1.0. ^ self].
	range _ self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar interval: 1.0; setValue: 0].
	interval _ ((self innerBounds width) / self totalScrollRange) asFloat.
	value _ (transform offset x / range min: 1.0) asFloat.
	scrollBar interval: interval.
	scrollBar setValue: value.! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 8/25/2003 21:24'!
initialize
	super initialize.
	self 
		color: Color red;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	self 
		initializeTransform;
		initializeScrollbar.
! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/25/2003 22:13'!
layoutWidgets
	| inner outer |
	outer _ super innerBounds.
	inner _ self innerBounds.
	transform bounds: inner.
	scrollBar bounds: ((inner left @ inner bottom + 1)
						corner: outer bottomRight)! !

!OBPaneScroller methodsFor: 'defaults' stamp: 'cwp 8/24/2003 15:13'!
separatorWidth
	^ 4! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 21:04'!
leftoverScrollRange
	^ (self totalScrollRange - self innerBounds width roundTo: self scrollDeltaWidth) max: 0
! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/23/2003 16:21'!
scrollDeltaWidth
	^ 1! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:07'!
paneCount
	^ (transform submorphs size / 2) ceiling.! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 12/8/2003 21:33'!
panes
	| panes |
	submorphs _ transform submorphs.
	panes _ Array new: (submorphs size / 2) ceiling.
	1 to: submorphs size by: 2 do: [:i | panes at: (i / 2) ceiling put: (submorphs at: i)].
	^ panes! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 8/24/2003 15:15'!
separator
	^ BorderedSubpaneDividerMorph vertical 
		borderWidth: self separatorWidth / 2;
		color: Color lightGray;
		borderRaised.! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 12/6/2003 17:06'!
clearPanes
	transform removeAllMorphs! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 8/25/2003 19:27'!
totalScrollRange
	| submorphBounds |
	submorphBounds := transform localSubmorphBounds ifNil: [^ 0].
	^ submorphBounds width
! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/24/2003 14:29'!
scrollBarHeight
	^ 12! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:08'!
paneHeight
	^ transform bounds height! !

!OBPaneScroller methodsFor: 'panes' stamp: 'cwp 12/6/2003 17:05'!
addPane: aMorph
	aMorph 
		borderWidth: 0;
		hResizing: #rigid;
		vResizing: #rigid;
		layoutInset: 0.
	transform hasSubmorphs ifTrue: [transform addMorphBack: self separator].
	transform addMorphBack: aMorph! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 8/25/2003 19:34'!
initializeTransform
	transform _ TransformMorph new.
	transform
		color: Color transparent;
		borderWidth: 0;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		disableTableLayout.
	self addMorphBack: transform.
! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 8/25/2003 22:02'!
innerBounds
	| rect |
	rect _ super innerBounds.
	^ rect withHeight: rect height - self scrollBarHeight - 1! !

!OBPaneScroller methodsFor: 'input events' stamp: 'cwp 8/22/2003 19:17'!
hideOrShowScrollBar
	! !

!OBPaneScroller methodsFor: 'scrolling' stamp: 'cwp 12/8/2003 21:42'!
scrollToRight
	^ scrollBar setValue: 1.! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:11'!
layoutPanes
	| widths rect |
	widths _ self computeMorphWidths.
	rect _ 0@0 extent: (0 @ self paneHeight).
	transform submorphs 
					with: widths 
					do: [:m :w | 
						rect _ rect withWidth: w.
						m bounds: rect.
						rect _ rect translateBy: (w@0)]
						
! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:11'!
computeMorphWidths
	| morphs widths paneWidth extra |
	morphs _ transform submorphs.
	widths _ Array new: morphs size.
	paneWidth _ self paneWidth.
	extra _ self extraPixelsForPaneWidth: paneWidth.
	(2 to: morphs size by: 2) do: [:i | widths at: i put: self separatorWidth].
	(1 to: extra by: 2) do: [:i | widths at: i put: paneWidth + 1].
	extra _ 1 max: (extra roundTo: 2) - 1.
	(extra to: morphs size by: 2) do: [:i | widths at: i put: paneWidth].
	^ widths! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:13'!
paneWidth
	| c total |
	c _ self paneCount.
	total _ self innerBounds width.
	c = 0 ifTrue: [^ self minPaneWidth].
	^ self minPaneWidth max: (total - (c - 1 * self separatorWidth) / c) floor! !

!OBPaneScroller methodsFor: 'initialization' stamp: 'cwp 11/23/2003 18:07'!
initializeScrollbar
	scrollBar _ OBScrollBar new model: self slotName: 'scrollBar'.
	scrollBar 
		borderWidth: 0;
		borderColor: #inset;
		height: self scrollBarHeight.
	self addMorphBack: scrollBar.! !

!OBPaneScroller methodsFor: 'defaults' stamp: 'cwp 12/6/2003 17:12'!
minPaneWidth
	^ 120! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/6/2003 17:10'!
extraPixelsForPaneWidth: width
	| c extra |
	c _ self paneCount.
	c = 0 ifTrue: [^ 0].
	extra _ self innerBounds width - (width * c) - (c - 1 * self separatorWidth).
	^ extra > 0 ifTrue: [extra] ifFalse: [0]	! !

!OBPaneScroller methodsFor: 'layout' stamp: 'cwp 12/8/2003 21:43'!
doLayout
	self layoutWidgets.
	self layoutPanes.
	self setScrollDeltas.
	self scrollToRight.! !

Slider subclass: #OBScrollBar
	instanceVariableNames: 'upButton downButton pagingArea scrollDelta pageDelta interval menuSelector timeOfMouseDown timeOfLastScroll nextPageDirection currentScrollDelay '
	classVariableNames: 'CachedImages UpArrow8Bit UpArrow '
	poolDictionaries: ''
	category: 'OmniBrowser-Morphs'!

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
extent: p
        p x > p y
                ifTrue: [super extent: (p max: 42@8)]
                ifFalse: [super extent: (p max: 8@42)]! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:07'!
totalSliderArea
	| upperBoundsButton |
	upperBoundsButton _ upButton.
	upButton bottom > upperBoundsButton bottom
		ifTrue: [upperBoundsButton _ upButton].
	^ bounds isWide
		ifTrue: [upperBoundsButton bounds topRight corner: downButton bounds bottomLeft]
		ifFalse: [upperBoundsButton bounds bottomLeft corner: downButton bounds topRight].
! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
alternativeScrollbarLook
	^Preferences alternativeScrollbarLook! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDown
	self flag: #obsolete.
	downButton eventHandler: nil.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollDownInit! !

!OBScrollBar methodsFor: 'scroll timing' stamp: 'cwp 11/23/2003 18:07'!
resetTimer
	timeOfMouseDown _ Time millisecondClockValue.
	timeOfLastScroll _ timeOfMouseDown - 1000 max: 0.
	nextPageDirection _ nil.
	currentScrollDelay _ nil! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
scrollDelta
	^ scrollDelta! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUpInit
	upButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollUp.
	self startStepping.! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:07'!
sliderThickness
	^ self roundedScrollbarLook ifTrue:[15] ifFalse:[super sliderThickness]! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializePagingArea
	pagingArea := RectangleMorph newBounds: self totalSliderArea
								color: (Color r: 0.6 g: 0.6 b: 0.8).
	pagingArea borderWidth: 0.
	pagingArea on: #mouseDown send: #scrollPageInit: to: self.
	pagingArea on: #mouseUp send: #finishedScrolling to: self.
	self addMorph: pagingArea.
	self roundedScrollbarLook 
		ifTrue:[pagingArea color: (Color gray: 0.9)].! !

!OBScrollBar methodsFor: 'testing' stamp: 'cwp 11/23/2003 18:06'!
stepTime
	^ currentScrollDelay ifNil: [300]! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollBarAction
	^self valueOfProperty: #scrollBarAction! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeDownButton
	downButton := RectangleMorph
		newBounds: (self innerBounds bottomRight - self buttonExtent extent: self buttonExtent)
		color: self thumbColor.
	downButton on: #mouseDown send: #scrollDownInit to: self.
	downButton on: #mouseUp send: #finishedScrolling to: self.
	downButton addMorphCentered: (ImageMorph new image: 
		(self 
			cachedImageAt: (bounds isWide ifTrue: ['right'] ifFalse: ['down']) 
			ifAbsentPut: [
				self upArrow8Bit
					rotateBy: (bounds isWide ifTrue: [#right] ifFalse: [#pi])
					centerAt: 0@0
			]
		)
	).
	self roundedScrollbarLook ifTrue:[
		downButton color: Color veryLightGray.
		downButton borderStyle: (BorderStyle complexRaised width: 3).
	] ifFalse:[
		downButton setBorderWidth: 1 borderColor: #raised.
	].
	self addMorph: downButton.
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
setNextDirectionFromEvent: event

	nextPageDirection _ bounds isWide ifTrue: [
		event cursorPoint x >= slider center x
	]
	ifFalse: [
		event cursorPoint y >= slider center y
	]

! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDownInit
	downButton borderInset.
	self resetTimer.
	self scrollBarAction: #doScrollDown.
	self startStepping.! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeEmbedded: aBool
	"aBool == true => inboard scrollbar
	aBool == false => flop-out scrollbar"
	self roundedScrollbarLook ifFalse:[^self].
	aBool ifTrue:[
		self borderStyle: (BorderStyle inset width: 2).
		self cornerStyle: #square.
	] ifFalse:[
		self borderStyle: (BorderStyle width: 1 color: Color black).
		self cornerStyle: #rounded.
	].
	self removeAllMorphs.
	self initializeSlider.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
sliderShadowColor
	^ self roundedScrollbarLook
		ifTrue: [self sliderColor darker]
		ifFalse: [super sliderShadowColor]
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollPageInit: evt
	self resetTimer.
	self setNextDirectionFromEvent: evt.
	self scrollBarAction: #doScrollByPage.
	self startStepping.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
interval: d
	"Supply an optional floating fraction so slider can expand to indicate range"
	interval _ d min: 1.0.
	self expandSlider.
	self computeSlider.! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUp: count
	self setValue: (value - (scrollDelta * count) - 0.000001 max: 0.0)! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
sliderExtent
	"The sliderExtent is now stored in the slider itself, not hardcoded as it is in the superclass."
	^slider extent! !

!OBScrollBar methodsFor: 'initialization' stamp: 'cwp 11/23/2003 18:07'!
initialize
	super initialize.
	scrollDelta _ 0.02.
	pageDelta _ 0.2.
	self roundedScrollbarLook ifTrue:[
		self borderStyle: ((BorderStyle complexFramed width: 2) "baseColor: Color gray")].! !

!OBScrollBar methodsFor: 'testing' stamp: 'cwp 11/23/2003 18:06'!
wantsSteps
	^self scrollBarAction notNil! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollUp
	self flag: #obsolete.
	upButton eventHandler: nil.
	upButton on: #mouseDown send: #scrollUpInit to: self.
	upButton on: #mouseUp send: #finishedScrolling to: self.
	^self scrollUpInit! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollDown
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value + scrollDelta + 0.000001 min: 1.0)! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollByPage
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 300 delay2: 100) ifFalse: [^ self].
	nextPageDirection
		ifTrue: [self setValue: (value + pageDelta min: 1.0)]
		ifFalse: [self setValue: (value - pageDelta max: 0.0)]
! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
finishedScrolling
	self stopStepping.
	self scrollBarAction: nil.
	self roundedScrollbarLook ifTrue:[
		upButton borderStyle: (BorderStyle complexRaised width: upButton borderWidth).
		downButton borderStyle: (BorderStyle complexRaised width: downButton borderWidth).
	] ifFalse:[
		downButton borderRaised.
		upButton borderRaised.
	].

! !

!OBScrollBar class methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2003 18:07'!
alwaysShowFlatScrollbarForAlternativeLook
	"Set this value to true, if you want to see the flat scrollbar look in flop-out mode as well as inboard.  Otherwise the flop-out scrollbar will be rounded and inboard will be flat."
	^ false! !

!OBScrollBar methodsFor: 'other events' stamp: 'cwp 11/23/2003 18:06'!
mouseDownInSlider: event
	interval = 1.0 ifTrue:
		["make the entire scrollable area visible if a full scrollbar is clicked on"
		self setValue: 0.
		self model hideOrShowScrollBar].
	super mouseDownInSlider: event! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeSlider
	self roundedScrollbarLook ifTrue:[
		self 
			initializeUpButton;
			initializeDownButton;
			initializePagingArea.
	] ifFalse:[
		self initializeUpButton; 
			initializeDownButton; 
			initializePagingArea.
	].
	super initializeSlider.
	self roundedScrollbarLook ifTrue:[
		slider cornerStyle: #rounded.
		slider borderStyle: (BorderStyle complexRaised width: 3).
		sliderShadow cornerStyle: #rounded.
	].
	self sliderColor: self sliderColor.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
scrollDelta: d1 pageDelta: d2
	"Supply optional increments for better scrolling of, eg, text"
	scrollDelta _ d1.
	pageDelta _ d2.! !

!OBScrollBar methodsFor: 'accessing' stamp: 'cwp 11/23/2003 18:06'!
adoptPaneColor: aColor
	"Adopt the given pane color"
	self alternativeScrollbarLook ifFalse:[^self].
	aColor ifNil:[^self].
	self sliderColor: aColor.! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollDown: count
	self setValue: (value + (scrollDelta * count) + 0.000001 min: 1.0)! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
scrollBarAction: aSymbol
	self setProperty: #scrollBarAction toValue: aSymbol! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
initializeUpButton
	upButton := self roundedScrollbarLook 
				ifTrue:  
					[RectangleMorph 
						newBounds: (self innerBounds topLeft extent: self buttonExtent)]
				ifFalse: 
					[RectangleMorph 
						newBounds: ((self innerBounds topLeft) extent: self buttonExtent)].
	upButton color: self thumbColor.
	upButton 
		on: #mouseDown
		send: #scrollUpInit
		to: self.
	upButton 
		on: #mouseUp
		send: #finishedScrolling
		to: self.
	upButton 
		addMorphCentered: (ImageMorph new image: (self 
						cachedImageAt: (bounds isWide ifTrue: ['left'] ifFalse: ['up'])
						ifAbsentPut: 
							[bounds isWide 
								ifTrue: [self upArrow8Bit rotateBy: #left centerAt: 0 @ 0]
								ifFalse: [self upArrow8Bit]])).
	self roundedScrollbarLook 
		ifTrue: 
			[upButton color: Color veryLightGray.
			upButton borderStyle: (BorderStyle complexRaised width: 3)]
		ifFalse: [upButton setBorderWidth: 1 borderColor: #raised].
	self addMorph: upButton! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
expandSlider
	"Compute the new size of the slider (use the old sliderThickness as a minimum)."
	| r |
	r _ self totalSliderArea.
	slider extent: (bounds isWide
		ifTrue: [((r width * interval) asInteger max: self sliderThickness) @ slider height]
		ifFalse: [slider width @ ((r height * interval) asInteger max: self sliderThickness)])! !

!OBScrollBar methodsFor: 'scrolling' stamp: 'cwp 11/23/2003 18:06'!
doScrollUp
	"Scroll automatically while mouse is down"
	(self waitForDelay1: 200 delay2: 40) ifFalse: [^ self].
	self setValue: (value - scrollDelta - 0.000001 max: 0.0)! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
thumbColor
	"Problem: Part of the ScrollBar/Slider code uses 'slider' to mean the entire scrollbar/slider widget, and part of it uses 'slider' to mean only the draggable 'thumb'.  This should be cleaned up so that 'thumb' is used instead of 'slider' where appropriate.  For now, the meaning of thumbColor is clear, at least."

	^ self alternativeScrollbarLook 
		ifTrue: [self sliderColor alphaMixed: 0.7 with: (Color gray: 0.95)]
		ifFalse: [Color veryLightGray]! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
pagingArea
	^pagingArea! !

!OBScrollBar methodsFor: 'stepping and presenter' stamp: 'cwp 11/23/2003 18:07'!
step
	| action |
	action _ self scrollBarAction.
	action ifNotNil:[self perform: action].! !

!OBScrollBar methodsFor: 'scroll timing' stamp: 'cwp 11/23/2003 18:07'!
waitForDelay1: delay1 delay2: delay2 
	"Return true if an appropriate delay has passed since the last scroll operation.
	The delay decreases exponentially from delay1 to delay2."

	| now scrollDelay |
	timeOfLastScroll isNil ifTrue: [self resetTimer].	"Only needed for old instances"
	now := Time millisecondClockValue.
	(scrollDelay := currentScrollDelay) isNil 
		ifTrue: [scrollDelay := delay1	"initial delay"].
	currentScrollDelay := scrollDelay * 9 // 10 max: delay2.	"decrease the delay"
	timeOfLastScroll := now.
	^true! !

!OBScrollBar methodsFor: 'as yet unclassified' stamp: 'cwp 11/23/2003 18:06'!
cachedImageAt: aKey ifAbsentPut: aBlock

	CachedImages ifNil: [CachedImages _ Dictionary new].
	^CachedImages at: aKey ifAbsentPut: aBlock! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
roundedScrollbarLook
	"Rounded look currently only shows up in flop-out mode"
	^Preferences alternativeScrollbarLook and: [Preferences inboardScrollbars not and: [self class alwaysShowFlatScrollbarForAlternativeLook not]]
! !

!OBScrollBar methodsFor: 'other events' stamp: 'cwp 11/23/2003 18:06'!
menuButtonMouseDown: event
	event hand showTemporaryCursor: nil.
	self use: menuSelector orMakeModelSelectorFor: 'MenuButtonPressed:'
		in: [:sel | menuSelector _ sel.  model perform: sel with: event]! !

!OBScrollBar methodsFor: 'geometry' stamp: 'cwp 11/23/2003 18:06'!
buttonExtent
	^ bounds isWide
		ifTrue: [11 @ self innerBounds height]
		ifFalse: [self innerBounds width @ 11]! !

!OBScrollBar methodsFor: 'initialize' stamp: 'cwp 11/23/2003 18:06'!
upArrow8Bit

	"convert to 8-bit and convert white to transparent to avoid gratuitous conversion every time we put one in an ImageMorph"

	^UpArrow8Bit ifNil: [
		UpArrow8Bit _ (ColorForm mappingWhiteToTransparentFrom: UpArrow) asFormOfDepth: 8
	]! !

!OBScrollBar class methodsFor: 'class initialization' stamp: 'cwp 11/23/2003 18:07'!
initialize "ScrollBar initialize"

	UpArrow _ Form
		extent: 6@3
		fromArray: #(2r11e28 2r1111e27 2r111111e26)
		offset: 0@0.! !

!OBScrollBar methodsFor: 'access' stamp: 'cwp 11/23/2003 18:06'!
sliderColor: aColor
	"Change the color of the scrollbar to go with aColor."
	| buttonColor |
	super sliderColor: aColor.
	buttonColor _ self thumbColor.
	upButton color: buttonColor.
	downButton color: buttonColor.
	slider color: buttonColor.
	self alternativeScrollbarLook ifTrue:
		[self roundedScrollbarLook
			ifTrue:
				[self color: Color transparent.
				pagingArea color: aColor muchLighter.
				self borderStyle style == #simple 
					ifTrue:[self borderColor: aColor darker darker]
					ifFalse:[self borderStyle baseColor: aColor]]
			ifFalse:
				[pagingArea color: (aColor alphaMixed: 0.3 with: Color white).
				self borderWidth: 0]]
! !

!OBScrollBar methodsFor: 'model access' stamp: 'cwp 11/23/2003 18:06'!
setValue: newValue
	"Using roundTo: instead of truncateTo: ensures that scrollUp will scroll the same distance as scrollDown."
	^ super setValue: (newValue roundTo: scrollDelta)! !

PackageInfo subclass: #OBFakePackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:36'!
systemCategories
	^ Array with: 'OmniBrowser-Tests'! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 22:44'!
classes
	^ Array
		with: OBFakeClassA
		with: OBFakeClassB
		with: OBFakeClassC	! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 22:35'!
packageName
	^ 'OmniBrowserFakes'! !

!OBFakePackage methodsFor: 'as yet unclassified' stamp: 'cwp 12/10/2003 23:31'!
systemCategoryPrefix
	^ 'OmniBrowser'! !

!PackageInfo methodsFor: '*omnibrowser' stamp: 'cwp 12/14/2003 21:05'!
classesInCategory: shortName
	| fullName |
	fullName _ self systemCategoryPrefix, '-', shortName.
	^ self classes select: [:class | class category = fullName]! !

!PackageInfo methodsFor: '*omnibrowser' stamp: 'cwp 12/14/2003 21:06'!
shortNameOf: aSystemCategoryName
	^ aSystemCategoryName allButFirst: self systemCategoryPrefix size + 1! !

!PackageInfo methodsFor: '*omnibrowser' stamp: 'cwp 12/14/2003 21:02'!
categoryOf: aClass
	^ self shortNameOf: aClass category! !

!PackageInfo methodsFor: '*omnibrowser' stamp: 'cwp 12/14/2003 21:00'!
categories
	^ self systemCategories collect: [:cat | self shortNameOf: cat]! !

TestResource subclass: #OBDirectoryResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
tearDown
	self dataDir recursiveDelete! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 22:44'!
dataDirName
	^ 'obtest'! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 11/28/2003 22:47'!
dataDir
	^ FileDirectory default directoryNamed: self dataDirName! !

!OBDirectoryResource methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
setUp
	| dir |
	dir _ self dataDir.
	dir assureExistence.
	#(alpha beta gamma) do: [:filename | | file | file _ dir forceNewFileNamed: filename.
							  file nextPutAll: filename.
							  file close].
	dir createDirectory: 'delta'.
	(dir directoryNamed: 'delta') createDirectory: 'epsilon'.! !

TestCase subclass: #OBDictionaryNodeTest
	instanceVariableNames: 'node '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDictionaryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:15'!
setUp
	| dict |
	dict _ Dictionary new.
	dict
		at: #one put: 1;
		at: #two put: 2;
		at: #three put: 3.
	node _ OBDictionaryNode on: dict! !

!OBDictionaryNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:16'!
testNames
	| list |
	list _ node associations collect: [:n | n name].
	self assert: (list includesAllOf: #(one two three))! !

TestCase subclass: #OBFileNodeTest
	instanceVariableNames: 'node notification '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 22:06'!
testDelete
	| actions delete |
	actions _ node actions.
	delete _ actions detect: [:a | a label = 'delete'] ifNone: [self signalFailure: 'No delete action'].
	delete monitor: self.
	delete trigger.
	self deny: ((FileDirectory default) fileExists: self dataFile).
	self assert: notification class = OBNodeDeleted

	! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:41'!
testText
	self assert: (node text = 'alpha')! !

!OBFileNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:32'!
resources
	^ Array with: OBDirectoryResource! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/7/2004 21:38'!
tearDown
	| file |
	file _ FileStream fileNamed: self dataFile.
	file
		reset;
		nextPutAll: 'alpha';
		truncate: (file position);
		close.! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:40'!
setUp
	node _ OBFileNode on: self dataFile.! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:15'!
dataFile
	^ OBDirectoryResource current dataDir fullNameFor: 'alpha'! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/23/2004 23:15'!
notification: aNotification
	notification _ aNotification! !

!OBFileNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:41'!
testName
	self assert: node name = 'alpha'! !

TestCase subclass: #OBPaneScrollerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBPaneScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:04'!
metaNode
	^ OBFakeNode metaGraph! !

!OBPaneScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:03'!
metaNodes
	^ OBFakeNode metaGraph! !

!OBPaneScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/14/2003 22:24'!
hasFilters
	^ false! !

!OBPaneScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/6/2003 17:11'!
testExtraPixels
	| scroller |
	(scroller _ OBPaneScroller new)
		addPane: self createColumn morph;
		addPane: self createColumn morph.
	self assert: (scroller extraPixelsForPaneWidth: scroller paneWidth) < 2
	! !

!OBPaneScrollerTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:04'!
createColumn
	^ OBColumn inBrowser: self metaNode: self metaNode node: OBFakeNode new! !

TestCase subclass: #OBFileRegistryActorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileRegistryActorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:26'!
assertActions: actions include: required
	| labels |
	labels _ actions collect: [:act | act label].
	self assert: (required includesAllOf: labels)! !

!OBFileRegistryActorTest methodsFor: 'as yet unclassified' stamp: 'cwp 1/24/2004 00:26'!
testTextFile
	| actor node actions |
	actor _ OBFileRegistryActor new.
	node _ OBFileNode on: (FileDirectory default fullNameFor: 'foo.txt').
	actions _ actor actionsForNode: node.
	self assertActions: actions include: #('add file to new zip' 'compress file').! !

TestCase subclass: #OBFileNodeEditTest
	instanceVariableNames: 'node '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:30'!
createFile
	| file |
	file _ FileStream newFileNamed: self dataFile.
	file
		nextPutAll: 'omega';
		close.
! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:27'!
dataFile
	^ OBDirectoryResource current dataDir fullNameFor: 'omega'! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:40'!
testAcceptText
	| file |
	node text: 'foo'.
	file _ FileStream readOnlyFileNamed: self dataFile.
	self assert: file contents = 'foo'! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/15/2003 21:40'!
setUp
	self createFile.
	node _ OBFileNode on: self dataFile.
	! !

!OBFileNodeEditTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:28'!
tearDown
	FileDirectory deleteFilePath: self dataFile! !

TestCase subclass: #OBBrowserTest
	instanceVariableNames: 'model morph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

OBBrowserTest subclass: #OBFakeBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectA
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:30'!
testSelectC
	self select: #c.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #().
	self assertTextIs: 'c'! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:13'!
metaGraph
	^ OBFakeNode metaGraph! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 16:44'!
testInitialDisplay
	self assert: self listMorphs size = 1.
	self assertListAt: 1 contains: #(a b c).
	self assertTextIs: ''.
	! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:59'!
testAcceptText
	self select: #a.
	self assertListAt: 1 contains: #(a b c).
	self assertListAt: 2 contains: #(aa ab ac).
	self assertTextIs: 'a'.
	self setText: 'x'.
	self assertListAt: 1 contains: #(x b c).
	self assertListAt: 2 contains: #(xa xb xc).
	self assertTextIs: 'x'
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/7/2003 19:29'!
testDeselectA
	self select: #a.
	self deselect: #a.
	self assertListAt: 1 contains: #(a b c).
	self assert: self listMorphs size = 1.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/8/2003 20:33'!
testPanes
	| scroller |
	self assert: (self morphsOfClass: PluggableListMorph) size = 1.
	self assert: (self morphsOfClass: PluggableTextMorph) size = 1.
	scroller _ self morphNamed: 'scroller'.
	self assert: scroller panes size = model minPanes.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/23/2004 21:33'!
testDeleteB
	self select: #b.
	self selectMenuItem: 'delete'.
	self assertListAt: 1 contains: #(a c).
	self assert: self listMorphs size = 1.
	self assertTextIs: ''.! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 11/23/2003 13:12'!
testCreateWindow
	self assert: (morph isKindOf: SystemWindow).
	self assert: (morph label = 'OmniBrowser').
! !

!OBFakeBrowserTest methodsFor: 'testing' stamp: 'cwp 1/7/2004 08:27'!
testAction
	self select: #a.
	self selectMenuItem:  'become z'.
	self assertListAt: 1 contains:  #(z b c)! !

!OBFakeBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:12'!
node
	^ OBFakeNode new! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 1/23/2004 23:30'!
selectMenuItem: aString
	| item |
	item _ self menuItemNamed: aString.
	item ifNil: [self signalFailure: 'Menu item ''', aString, ''' does not exist.'].
	item doButtonAction! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertAListIncludes: anArrayOfStrings
	self listMorphs 
			detect: [:m | m getList includesAllOf: anArrayOfStrings]
			ifNone: [self assert: false].! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphsOfClass: aClass
	| found |
	found _ OrderedCollection new.
	morph allMorphsDo: [:m | (m isMemberOf: aClass) ifTrue: [found add: m]].
	^ found! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
morphNamed: aString
	^ morph 
		findDeepSubmorphThat: [:m | m knownName = aString]
		ifAbsent: [self signalFailure: aString, 'not found']! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:07'!
findListContaining: aString
	^ self listMorphs detect: [:m | m getList includes: aString] ifNone: []! !

!OBBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 16:39'!
setUp
	model _ OBBrowser metaNode: self metaGraph node: self node.
	morph _ model window.! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
setText: aString
	| textMorph |
	textMorph _ self textMorph.
	textMorph 
		selectAll;
		replaceSelectionWith: aString asText;
		accept.
	! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 1/23/2004 22:35'!
assertMenuContains: aString
	| item |
	item _ self menuItemNamed: aString.
	self assert: item notNil! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
textMorph
	^ (self morphsOfClass: PluggableTextMorph) last! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
deselect: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	listMorph changeModelSelection: 0.! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 12/17/2003 15:08'!
listMorphs
	^ self morphsOfClass: PluggableListMorph! !

OBBrowserTest subclass: #OBMetaGraphBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 19:50'!
node
	^ OBDictionaryNode on: OBBrowser metaGraphs! !

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:22'!
testInitialDisplay
	self listMorphs size = 1.
	self assertAListIncludes: #(System Package Image FileSystem).
	self assertTextIs: ''.
	! !

!OBMetaGraphBrowserTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/18/2003 20:23'!
metaGraph
	^ OBMetaGraphBuilder default metaGraphBrowser! !

OBBrowserTest subclass: #OBPackageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBPackageBrowserTest methodsFor: 'running' stamp: 'cwp 12/18/2003 18:34'!
metaGraph
	^ OBMetaGraphBuilder default packageBrowser ! !

!OBPackageBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 18:21'!
testSelectFakeA
	self select: 'Tests'.
	self select: 'OBFakeClassA'.
	self assertListAt: 1 contains: #('Tests').
	self assertListAt: 2 contains: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertListAt: 3 contains: #('letters' 'numbers').
	self assertTextIs: 'Object subclass: #OBFakeClassA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''OmniBrowser-Tests'''! !

!OBPackageBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 18:09'!
node
	^ OBPackageNode on: OBFakePackage default! !

!OBPackageBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 18:29'!
testSelectOne
	self select: 'Tests'.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self select: 'one'.
	self assertListAt: 1 contains: #('Tests').
	self assertListAt: 2 contains: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertListAt: 3 contains: #('letters' 'numbers').
	self assertListAt: 4 contains: #('one' 'two' 'three').
	self assertTextIs: ((MethodReference class: OBFakeClassA selector: #one) source)! !

!OBPackageBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 18:26'!
testSelectNumbers
	self select: 'Tests'.
	self select: 'OBFakeClassA'.
	self select: 'numbers'.
	self assertListAt: 1 contains: #('Tests').
	self assertListAt: 2 contains: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertListAt: 3 contains: #('letters' 'numbers').
	self assertListAt: 4 contains: #('one' 'two' 'three').
	self assertTextIs: 'OBFakeClassA organization addCategory: ''numbers'''! !

!OBPackageBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 18:12'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 contains: #('Tests').
	self assertTextIs: ''.
	! !

!OBPackageBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 18:14'!
testSelectTests
	self select: 'Tests'.
	self assertListAt: 1 contains: #('Tests').
	self assertListAt: 2 contains: #(OBFakeClassA OBFakeClassB OBFakeClassC).
	self assertTextIs: ''! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertTextIs: aString
	self assert: self textMorph text = aString.! !

!OBBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 15:10'!
isAbstract
	^ self name = 'OBBrowserTest'! !

!OBBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/17/2003 15:08'!
select: aString
	| listMorph |
	listMorph _ self findListContaining: aString.
	self assert: listMorph notNil.
	listMorph changeModelSelection: (listMorph getList indexOf: aString).! !

OBBrowserTest subclass: #OBDirectoryBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 1/23/2004 23:33'!
testMenuItems
	self select: 'alpha'.
	self assertMenuContains: 'delete'! !

!OBDirectoryBrowserTest methodsFor: 'running' stamp: 'cwp 12/17/2003 15:14'!
node
	^ OBDirectoryNode on: OBDirectoryResource current dataDir! !

!OBDirectoryBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/17/2003 15:09'!
resources
	^ Array with: OBDirectoryResource! !

!OBDirectoryBrowserTest methodsFor: 'running' stamp: 'cwp 12/18/2003 18:33'!
metaGraph
	^ OBMetaGraphBuilder default fileSystemBrowser! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 15:19'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertTextIs: ''.
	! !

!OBDirectoryBrowserTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 17:01'!
testSelectAlpha
	self select: 'alpha'.
	self assertListAt: 1 contains: #(alpha beta gamma delta).
	self assertTextIs: 'alpha'! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertListAt: index contains: items
	| list |
	list _ (self listMorphs at: index) getList.
	self assert: (list size = items size).
	self assert: (list includesAllOf: items).! !

!OBBrowserTest methodsFor: 'examining' stamp: 'cwp 1/26/2004 21:53'!
menuItemNamed: aString
	| lists current |
	lists _ self listMorphs.
	current _ lists reversed detect: [:list | list selection notNil].
	^ (current getMenu: true) itemWithWording: aString.
! !

!OBBrowserTest methodsFor: 'asserting' stamp: 'cwp 12/17/2003 15:07'!
assertAListMatches: strings
	| listMorphs list |
	listMorphs _ self listMorphs.
	listMorphs 
		detect: [:m | list _ m getList. (list size = strings size) and: [list includesAllOf: strings]]
		ifNone: [self assert: false].! !

TestCase subclass: #OBDirectoryNodeTest
	instanceVariableNames: 'node '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniBrowser-Tests'!

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:39'!
testName
	self assert: node name = 'obtest'! !

!OBDirectoryNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2003 22:32'!
resources
	^ Array with: OBDirectoryResource! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 15:01'!
testDirectoryNodes
	| children |
	children _ node directories collect: [:n | n name].
	self assert: children = #(delta)
	! !

!OBDirectoryNodeTest methodsFor: 'data' stamp: 'cwp 11/28/2003 22:47'!
dataDir
	^ OBDirectoryResource current dataDir! !

!OBDirectoryNodeTest methodsFor: 'running' stamp: 'cwp 12/15/2003 21:39'!
setUp
	node _ OBDirectoryNode on: self dataDir.! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/15/2003 21:39'!
testText
	self assert: (node text endsWith: '
----------
alpha - 5 bytes
beta - 4 bytes
delta - 0 bytes
gamma - 5 bytes
')
! !

!OBDirectoryNodeTest methodsFor: 'testing' stamp: 'cwp 12/17/2003 14:49'!
testFileNodes
	| children |
	children _ node files.
	self assert: (children collect: [:n | n name]) = #(alpha beta gamma)
	! !
OBBrowser initialize!
OBMetaGraphBuilder initialize!
OBScrollBar initialize!
